#include "TextEnhance.hpp"
#include "Scanner.hpp"
#include <ES2Command/ES2CommandAPI.h>
#include <utils/PathUtils.h>
#include <utils/ESFile.h>

namespace epsonscan {

static std::string GetPluginRootDir()
{
	  std::string strModulePath = EPSON_INSTALL_PATH;
      ES_CMN_FUNCS::PATH::ES_CombinePath(strModulePath, strModulePath, ES_STRING("non-free-exec"));
	  return strModulePath;
}

void TextEnhance::SetValue(const SDIInt& intVal)
{
	current_ = intVal;
}

void TextEnhance::Reset()
{
	current_  = kSDITextEnhanceLevelNone;
}

void TextEnhance::GetValue(SDIInt& intVal)
{
	intVal = current_;
}

void TextEnhance::GetCapability(SDICapability &capability)
{
	SetDefaultListCapability(capability);
	ESIndexSet availableColorTypes;
  	capability.supportLevel = kSDISupportLevelNone;

	ESString ddeName;
	ESString imfName;
		
	ModelInfo* modelInfo = dataProvider_->GetModelInfo().get();
		
	modelInfo->GetValue(kPrvHRD_DDEName, ddeName);
	modelInfo->GetValue(kPrvHRD_DDEName, imfName);
	if (ddeName == "EsDDE6.dll" && imfName =="EsIMF6.dll")
	{
		std::string pluginRoot = GetPluginRootDir();
		ESString ddePlugin;
		ESString ddeso;
		ESString imfso;
		ES_CMN_FUNCS::PATH::ES_CombinePath(ddePlugin, pluginRoot, ES_STRING("ddePlugin"));
		ES_CMN_FUNCS::PATH::ES_CombinePath(ddeso, pluginRoot, ES_STRING("libdde6.so"));
		ES_CMN_FUNCS::PATH::ES_CombinePath(imfso, pluginRoot, ES_STRING("libimf6.so"));

		if (ES_CMN_FUNCS::PATH::ES_IsExistFile(ddePlugin) && 
			ES_CMN_FUNCS::PATH::ES_IsExistFile(ddeso) &&
			ES_CMN_FUNCS::PATH::ES_IsExistFile(imfso))
		{
			capability.supportLevel = kSDISupportLevelAvailable;
		}
	}
}

ESDictionary TextEnhance::GetEngineKeyValues()
{
	auto dict =  ESDictionary();
	return dict;
}
	
}//namespace epsonscan
