//  scanbutton.h -- template and derived ESC/I ESC/I-2 protocol commands
//  Copyright (C) 2018-2019  SEIKO EPSON CORPORATION
//
//  License: GPL-3.0+
//  Author : SEIKO EPSON CORPORATION
//
//  This file is part of the 'Epson Scan 2' package.
//  This package is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License or, at
//  your option, any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//  You ought to have received a copy of the GNU General Public License
//  along with this package.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SCANBUTTON_H
#define SCANBUTTON_H

#include <QPushButton>
#include "capitem.h"
#include "supervisor.h"
#include "custommessagebox.h"

class ScanButton : public QPushButton
{
public:
    ScanButton(QWidget *parent = 0);

    void initialize(CustomMessageBox* msg_box);

    void Button_pressed(Supervisor* sv, bool Add_Pages);

private:

    CustomMessageBox* m_messageBox;
};


#endif // SCANBUTTON_H
