//  sleeptimerspinbox.h -- template and derived ESC/I ESC/I-2 protocol commands
//  Copyright (C) 2018-2019  SEIKO EPSON CORPORATION
//
//  License: GPL-3.0+
//  Author : SEIKO EPSON CORPORATION
//
//  This file is part of the 'Epson Scan 2' package.
//  This package is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License or, at
//  your option, any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//  You ought to have received a copy of the GNU General Public License
//  along with this package.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SLEEPTIMERSPINBOX_H
#define SLEEPTIMERSPINBOX_H

#include <QFocusEvent>
#include <QSpinBox>
#include "supervisor.h"

class SleepTimerSpinBox : public QSpinBox
{
public:
    SleepTimerSpinBox(QWidget *parent = 0);

    void initialize(INT_SETTING_VALUE sleep_time_para);

    void update_ui(void);

    void item_event(int value);

    int get_current_item(void);

private:
    bool changed;
    bool enabled;

    int current_value;

    void set_enabled(bool enabled);

    void select_item(int select);

};

#endif // SLEEPTIMERSPINBOX_H
